function u=diffusion_model_pdex11(D2,D1,D0,tau,tau2,A,thickness,points,delays)

m = 0;

x = linspace(0,thickness,points);

sol = pdepe(m,@pdex1pde,@pdex1ic,@pdex1bc,x,delays);

% Extract the first solution component as u.
u = sol(:,:,1);

% --------------------------------------------------------------
function [c,f,s] = pdex1pde(x,t,u,DuDx)
    

c=1;
f = DuDx*(D0+D1*exp(-t/tau)+D2*exp(-t/tau2));


%% estimate recombination: 
% recombination rate (how great percentage recombines during 1ps with uniform distribution)
% multiplied by u or or u^2 or u^3 for 1st, 2nd and 3rd order

% 1st order recombination rate is given by: rate constant(1/s) * 10^(-12)s
% 2nd order recombination rate is given by: rate constant(cm^3/s) * carrier density(1/cm^3) * 10^(-12)s
% 3rd order recombination rate is given by: rate constant(cm^6/s) * carrier density(1/cm^3)^2 * 10^(-12)s

% note that the recombination rates must be given for a uniform carrier distribution for the normalization to work correctly

relative_power=1;
%
first_order_rate=0.00; %how large percentage recombines within 1ps
second_order_rate=0.00; %how large percentage recombines within 1ps with uniform distribution across the entire film
third_order_rate=0.00; %how large percentage recombines within 1ps with uniform distribution across the entire film
%}


s = -first_order_rate*u...
    -second_order_rate*relative_power*u^2 ...
    -third_order_rate*(relative_power)^2*u^3;

end
% --------------------------------------------------------------
function u0 = pdex1ic(x)
%initial distribution calculated from the absorbance ad film thickness

%normalizes the distribution so that the sum is 1
x0 = linspace(0,thickness,points);
norm_factor=points/sum(10.^(-A*x0/thickness));

u0=10^(-A*x/thickness)*norm_factor;
%

end
% --------------------------------------------------------------
function [pl,ql,pr,qr] = pdex1bc(xl,ul,xr,ur,t)
%boundary conditions

pl=0;
ql=1;
pr=0;
qr=1;

    %{
    pl = -10/10000*ul; %with surface recombination: S/D *ul
    
    ql = 1;
%}

end
    
end